package ch.hevs.isi.core;

import ch.hevs.isi.db.DatabaseConnector;
import ch.hevs.isi.field.FieldConnector;
import ch.hevs.isi.web.WebConnector;

import java.util.HashMap;
import java.util.Map;

public abstract class DataPoint{
    private static Map<String, DataPoint> dataPointMap = new HashMap<>();
    private String label;
    private boolean isOutput;
    protected DataPoint(String label, boolean isOutput){
        this.label = label;
        this.isOutput = isOutput;
    }
    protected void update(boolean isNewValue){

        if(isNewValue){
            dataPointMap.put(this.label, this);
        } else {
            dataPointMap.replace(this.label, this);
        }
        DatabaseConnector.getMySelf().onNewValue(this);
        WebConnector.getMySelf().onNewValue(this);
        FieldConnector.getMySelf().onNewValue(this);
    }
    public static DataPoint getDataPointFromLabel(String label){
        if( !dataPointMap.containsKey(label) ){
            return null;
        } else {
            DataPoint dp = dataPointMap.get(label);
            return dp;
        }

    }

    /**
     * Just get the label of this DataPoint
     * @return the label in a string
     */
    public String getLabel(){
        return this.label;
    }
    public boolean isOutput(){
        return this.isOutput;
    }

}

