package ch.hevs.isi.field;

import ch.hevs.isi.core.DataPoint;

import java.util.HashMap;

public abstract class ModbusRegister {
    private int address;
    public static HashMap<DataPoint, ModbusRegister> mapOfRegisters = new HashMap<>();
    public void updateMapOfRegisters(DataPoint dp, int address){
        this.address = address;
        mapOfRegisters.put(dp,this);
    }

    public int getAddress() {
        return address;
    }

    public static ModbusRegister getRegisterFromDatapoint(DataPoint dp){
        return mapOfRegisters.get(dp);
    }

    public static void poll(){
        for (ModbusRegister mr : mapOfRegisters.values()){
            mr.read();                              //read all values (registers) of the map
        }
    }
    public abstract void read();        //abstract prototype of the method read
    public abstract void write();       //abstract prototype of the method read
}
